
_Delay_6ms:

;One Wire LCD.c,26 :: 		void Delay_6ms() {
;One Wire LCD.c,27 :: 		Delay_ms(6);
	LDI        R17, 32
	LDI        R16, 42
L_Delay_6ms0:
	DEC        R16
	BRNE       L_Delay_6ms0
	DEC        R17
	BRNE       L_Delay_6ms0
	NOP
;One Wire LCD.c,28 :: 		}
L_end_Delay_6ms:
	RET
; end of _Delay_6ms

_Delay_15us:

;One Wire LCD.c,30 :: 		void Delay_15us() {
;One Wire LCD.c,31 :: 		Delay_us(10);
	LDI        R16, 13
L_Delay_15us2:
	DEC        R16
	BRNE       L_Delay_15us2
	NOP
;One Wire LCD.c,32 :: 		}
L_end_Delay_15us:
	RET
; end of _Delay_15us

_Send_Byte:

;One Wire LCD.c,34 :: 		void Send_Byte(char rs, char out_char) {
;One Wire LCD.c,35 :: 		char i = 0, mask = 0x80;
; mask start address is: 18 (R18)
	LDI        R18, 128
;One Wire LCD.c,37 :: 		out_char.F1 = rs;
	BST        R2, 0
	BLD        R3, 1
;One Wire LCD.c,39 :: 		for(i = 0; i < 7; i++) {    // send all 7 bits
; i start address is: 17 (R17)
	LDI        R17, 0
; mask end address is: 18 (R18)
; i end address is: 17 (R17)
L_Send_Byte4:
; i start address is: 17 (R17)
; mask start address is: 18 (R18)
	CPI        R17, 7
	BRLO       L__Send_Byte44
	JMP        L_Send_Byte5
L__Send_Byte44:
;One Wire LCD.c,40 :: 		if(out_char & mask) {   // if HI bit, make 1uS low pulse
	MOV        R16, R3
	AND        R16, R18
	BRNE       L__Send_Byte45
	JMP        L_Send_Byte7
L__Send_Byte45:
;One Wire LCD.c,41 :: 		One_Wire = 0;      // make LO pulse
	CBI        PORTD, 0
;One Wire LCD.c,42 :: 		One_Wire = 1;      // end LO pulse
	SBI        PORTD, 0
;One Wire LCD.c,43 :: 		Delay_15uS();      // safe 15uS pulse recovery
	CALL       _Delay_15us+0
;One Wire LCD.c,44 :: 		}
	JMP        L_Send_Byte8
L_Send_Byte7:
;One Wire LCD.c,46 :: 		One_Wire = 0;
	CBI        PORTD, 0
;One Wire LCD.c,47 :: 		Delay_15uS();      // 15uS LO pulse
	CALL       _Delay_15us+0
;One Wire LCD.c,48 :: 		One_Wire = 1;
	SBI        PORTD, 0
;One Wire LCD.c,49 :: 		Delay_15uS();      // 30uS recovery
	CALL       _Delay_15us+0
;One Wire LCD.c,50 :: 		Delay_15uS();
	CALL       _Delay_15us+0
;One Wire LCD.c,51 :: 		}
L_Send_Byte8:
;One Wire LCD.c,53 :: 		mask >>= 1;             // get the next bit
	MOV        R16, R18
	LSR        R16
	MOV        R18, R16
;One Wire LCD.c,39 :: 		for(i = 0; i < 7; i++) {    // send all 7 bits
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
;One Wire LCD.c,54 :: 		}
; mask end address is: 18 (R18)
; i end address is: 17 (R17)
	JMP        L_Send_Byte4
L_Send_Byte5:
;One Wire LCD.c,60 :: 		One_Wire = 0;        // send 8th bit, lo pulse = 14x15 = 210uS
	CBI        PORTD, 0
;One Wire LCD.c,62 :: 		Delay_us(210);
	LDI        R17, 2
	LDI        R16, 22
L_Send_Byte9:
	DEC        R16
	BRNE       L_Send_Byte9
	DEC        R17
	BRNE       L_Send_Byte9
	NOP
;One Wire LCD.c,63 :: 		One_Wire = 1;        // and hi recovery 20x15 = 300 uS
	SBI        PORTD, 0
;One Wire LCD.c,65 :: 		Delay_us(300);
	LDI        R17, 2
	LDI        R16, 142
L_Send_Byte11:
	DEC        R16
	BRNE       L_Send_Byte11
	DEC        R17
	BRNE       L_Send_Byte11
	NOP
;One Wire LCD.c,66 :: 		}
L_end_Send_Byte:
	RET
; end of _Send_Byte

_Write_Nibbles:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL
	IN         R29, SPH
	SBIW       R28, 1
	OUT        SPL, R28
	OUT        SPH, R29
	ADIW       R28, 1

;One Wire LCD.c,68 :: 		void Write_Nibbles(char rs, char out_char) {
;One Wire LCD.c,71 :: 		data2Send = out_char & 0xF0;
	PUSH       R3
	MOV        R16, R3
	ANDI       R16, 240
	STD        Y+0, R16
;One Wire LCD.c,73 :: 		data2Send.F3 = 1;
	LDD        R27, Y+0
	SBR        R27, 8
	STD        Y+0, R27
;One Wire LCD.c,74 :: 		Send_Byte(rs,data2Send);
	PUSH       R3
	LDD        R3, Y+0
	CALL       _Send_Byte+0
;One Wire LCD.c,75 :: 		data2Send.F3 = 0;
	LDD        R27, Y+0
	CBR        R27, 8
	STD        Y+0, R27
;One Wire LCD.c,76 :: 		Send_Byte(rs,data2Send);
	LDD        R3, Y+0
	CALL       _Send_Byte+0
	POP        R3
;One Wire LCD.c,78 :: 		data2Send = out_char & 0x0F;
	MOV        R16, R3
	ANDI       R16, 15
	STD        Y+0, R16
;One Wire LCD.c,79 :: 		data2Send <<= 4;
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	STD        Y+0, R16
;One Wire LCD.c,80 :: 		data2Send.F3 = 1;
	LDD        R27, Y+0
	SBR        R27, 8
	STD        Y+0, R27
;One Wire LCD.c,81 :: 		Send_Byte(rs,data2Send);
	LDD        R3, Y+0
	CALL       _Send_Byte+0
;One Wire LCD.c,82 :: 		data2Send.F3 = 0;
	LDD        R27, Y+0
	CBR        R27, 8
	STD        Y+0, R27
;One Wire LCD.c,83 :: 		Send_Byte(rs,data2Send);
	LDD        R3, Y+0
	CALL       _Send_Byte+0
;One Wire LCD.c,84 :: 		}
L_end_Write_Nibbles:
	POP        R3
	OUT        SPL, R28
	OUT        SPH, R29
	POP        R29
	POP        R28
	RET
; end of _Write_Nibbles

_Write_Nibble:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL
	IN         R29, SPH
	SBIW       R28, 1
	OUT        SPL, R28
	OUT        SPH, R29
	ADIW       R28, 1

;One Wire LCD.c,86 :: 		void Write_Nibble(char out_char) {
;One Wire LCD.c,87 :: 		char data2Send, rs = 0;
	PUSH       R2
	PUSH       R3
; rs start address is: 17 (R17)
	LDI        R17, 0
;One Wire LCD.c,89 :: 		data2Send = out_char & 0xF0;
	MOV        R16, R2
	ANDI       R16, 240
	STD        Y+0, R16
;One Wire LCD.c,91 :: 		data2Send.F3 = 1;
	LDD        R27, Y+0
	SBR        R27, 8
	STD        Y+0, R27
;One Wire LCD.c,92 :: 		Send_Byte(rs,data2Send);
	PUSH       R17
	LDD        R3, Y+0
	MOV        R2, R17
	CALL       _Send_Byte+0
	POP        R17
;One Wire LCD.c,93 :: 		data2Send.F3 = 0;
	LDD        R27, Y+0
	CBR        R27, 8
	STD        Y+0, R27
;One Wire LCD.c,94 :: 		Send_Byte(rs,data2Send);
	LDD        R3, Y+0
	MOV        R2, R17
; rs end address is: 17 (R17)
	CALL       _Send_Byte+0
;One Wire LCD.c,95 :: 		}
L_end_Write_Nibble:
	POP        R3
	POP        R2
	OUT        SPL, R28
	OUT        SPH, R29
	POP        R29
	POP        R28
	RET
; end of _Write_Nibble

_One_Wire_LCD_Cmd:

;One Wire LCD.c,97 :: 		void One_Wire_LCD_Cmd(char out_char) {
;One Wire LCD.c,98 :: 		char rs = 0;
	PUSH       R2
	PUSH       R3
; rs start address is: 16 (R16)
	LDI        R16, 0
;One Wire LCD.c,100 :: 		Write_Nibbles(rs,out_char);
	MOV        R3, R2
	MOV        R2, R16
; rs end address is: 16 (R16)
	CALL       _Write_Nibbles+0
;One Wire LCD.c,101 :: 		Delay_ms(5);
	LDI        R17, 26
	LDI        R16, 249
L_One_Wire_LCD_Cmd13:
	DEC        R16
	BRNE       L_One_Wire_LCD_Cmd13
	DEC        R17
	BRNE       L_One_Wire_LCD_Cmd13
;One Wire LCD.c,102 :: 		}
L_end_One_Wire_LCD_Cmd:
	POP        R3
	POP        R2
	RET
; end of _One_Wire_LCD_Cmd

_One_Wire_LCD_Chr:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL
	IN         R29, SPH
	SBIW       R28, 1
	OUT        SPL, R28
	OUT        SPH, R29
	ADIW       R28, 1

;One Wire LCD.c,104 :: 		void One_Wire_LCD_Chr(char row, char col, char out_char) {
;One Wire LCD.c,105 :: 		char rs = 1;
	PUSH       R2
	PUSH       R3
	LDI        R27, 1
	STD        Y+0, R27
;One Wire LCD.c,107 :: 		switch(row){
	JMP        L_One_Wire_LCD_Chr15
;One Wire LCD.c,108 :: 		case 1:
L_One_Wire_LCD_Chr17:
;One Wire LCD.c,109 :: 		One_Wire_LCD_Cmd(0x80 + col-1);
	MOV        R16, R3
	SUBI       R16, 128
	SUBI       R16, 1
	MOV        R2, R16
	CALL       _One_Wire_LCD_Cmd+0
;One Wire LCD.c,110 :: 		break;
	JMP        L_One_Wire_LCD_Chr16
;One Wire LCD.c,111 :: 		case 2:
L_One_Wire_LCD_Chr18:
;One Wire LCD.c,112 :: 		One_Wire_LCD_Cmd(0xC0 + col-1);
	MOV        R16, R3
	SUBI       R16, 64
	SUBI       R16, 1
	MOV        R2, R16
	CALL       _One_Wire_LCD_Cmd+0
;One Wire LCD.c,113 :: 		break;
	JMP        L_One_Wire_LCD_Chr16
;One Wire LCD.c,114 :: 		case 3:
L_One_Wire_LCD_Chr19:
;One Wire LCD.c,115 :: 		One_Wire_LCD_Cmd(0x94 + col-1);
	MOV        R16, R3
	SUBI       R16, 108
	SUBI       R16, 1
	MOV        R2, R16
	CALL       _One_Wire_LCD_Cmd+0
;One Wire LCD.c,116 :: 		break;
	JMP        L_One_Wire_LCD_Chr16
;One Wire LCD.c,117 :: 		case 4:
L_One_Wire_LCD_Chr20:
;One Wire LCD.c,118 :: 		One_Wire_LCD_Cmd(0xD4 + col-1);
	MOV        R16, R3
	SUBI       R16, 44
	SUBI       R16, 1
	MOV        R2, R16
	CALL       _One_Wire_LCD_Cmd+0
;One Wire LCD.c,119 :: 		break;
	JMP        L_One_Wire_LCD_Chr16
;One Wire LCD.c,120 :: 		}
L_One_Wire_LCD_Chr15:
	LDI        R27, 1
	CP         R2, R27
	BRNE       L__One_Wire_LCD_Chr50
	JMP        L_One_Wire_LCD_Chr17
L__One_Wire_LCD_Chr50:
	LDI        R27, 2
	CP         R2, R27
	BRNE       L__One_Wire_LCD_Chr51
	JMP        L_One_Wire_LCD_Chr18
L__One_Wire_LCD_Chr51:
	LDI        R27, 3
	CP         R2, R27
	BRNE       L__One_Wire_LCD_Chr52
	JMP        L_One_Wire_LCD_Chr19
L__One_Wire_LCD_Chr52:
	LDI        R27, 4
	CP         R2, R27
	BRNE       L__One_Wire_LCD_Chr53
	JMP        L_One_Wire_LCD_Chr20
L__One_Wire_LCD_Chr53:
L_One_Wire_LCD_Chr16:
;One Wire LCD.c,122 :: 		Write_Nibbles(rs,out_char);
	MOV        R3, R4
	LDD        R2, Y+0
	CALL       _Write_Nibbles+0
;One Wire LCD.c,123 :: 		}
L_end_One_Wire_LCD_Chr:
	POP        R3
	POP        R2
	OUT        SPL, R28
	OUT        SPH, R29
	POP        R29
	POP        R28
	RET
; end of _One_Wire_LCD_Chr

_One_Wire_LCD_Chr_Cp:

;One Wire LCD.c,125 :: 		void One_Wire_LCD_Chr_Cp(char out_char) {
;One Wire LCD.c,126 :: 		char rs = 1;
	PUSH       R2
	PUSH       R3
; rs start address is: 16 (R16)
	LDI        R16, 1
;One Wire LCD.c,128 :: 		Write_Nibbles(rs,out_char);
	MOV        R3, R2
	MOV        R2, R16
; rs end address is: 16 (R16)
	CALL       _Write_Nibbles+0
;One Wire LCD.c,129 :: 		}
L_end_One_Wire_LCD_Chr_Cp:
	POP        R3
	POP        R2
	RET
; end of _One_Wire_LCD_Chr_Cp

_One_Wire_LCD_Out:

;One Wire LCD.c,131 :: 		void One_Wire_LCD_Out(char row, char col, char *text) {
;One Wire LCD.c,132 :: 		while(*text)
L_One_Wire_LCD_Out21:
	MOVW       R30, R4
	LD         R16, Z
	TST        R16
	BRNE       L__One_Wire_LCD_Out56
	JMP        L_One_Wire_LCD_Out22
L__One_Wire_LCD_Out56:
;One Wire LCD.c,133 :: 		One_Wire_LCD_Chr(row,col++,*text++);
	MOVW       R30, R4
	LD         R16, Z
	PUSH       R5
	PUSH       R4
	PUSH       R3
	MOV        R4, R16
	CALL       _One_Wire_LCD_Chr+0
	POP        R3
	POP        R4
	POP        R5
	MOV        R16, R3
	SUBI       R16, 255
	MOV        R3, R16
	MOVW       R16, R4
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R4, R16
	JMP        L_One_Wire_LCD_Out21
L_One_Wire_LCD_Out22:
;One Wire LCD.c,134 :: 		}
L_end_One_Wire_LCD_Out:
	RET
; end of _One_Wire_LCD_Out

_One_Wire_LCD_Out_Cp:

;One Wire LCD.c,136 :: 		void One_Wire_LCD_Out_Cp(char *text) {
;One Wire LCD.c,137 :: 		while(*text)
L_One_Wire_LCD_Out_Cp23:
	MOVW       R30, R2
	LD         R16, Z
	TST        R16
	BRNE       L__One_Wire_LCD_Out_Cp58
	JMP        L_One_Wire_LCD_Out_Cp24
L__One_Wire_LCD_Out_Cp58:
;One Wire LCD.c,138 :: 		One_Wire_LCD_Chr_Cp(*text++);
	MOVW       R30, R2
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _One_Wire_LCD_Chr_Cp+0
	POP        R2
	POP        R3
	MOVW       R16, R2
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R2, R16
	JMP        L_One_Wire_LCD_Out_Cp23
L_One_Wire_LCD_Out_Cp24:
;One Wire LCD.c,139 :: 		}
L_end_One_Wire_LCD_Out_Cp:
	RET
; end of _One_Wire_LCD_Out_Cp

_One_Wire_LCD_Init:

;One Wire LCD.c,141 :: 		void One_Wire_LCD_Init() {
;One Wire LCD.c,142 :: 		Delay_ms(150);
	PUSH       R2
	LDI        R18, 4
	LDI        R17, 12
	LDI        R16, 52
L_One_Wire_LCD_Init25:
	DEC        R16
	BRNE       L_One_Wire_LCD_Init25
	DEC        R17
	BRNE       L_One_Wire_LCD_Init25
	DEC        R18
	BRNE       L_One_Wire_LCD_Init25
	NOP
	NOP
;One Wire LCD.c,143 :: 		Write_Nibble(0x30);
	LDI        R27, 48
	MOV        R2, R27
	CALL       _Write_Nibble+0
;One Wire LCD.c,144 :: 		Delay_ms(30);
	LDI        R17, 156
	LDI        R16, 215
L_One_Wire_LCD_Init27:
	DEC        R16
	BRNE       L_One_Wire_LCD_Init27
	DEC        R17
	BRNE       L_One_Wire_LCD_Init27
	NOP
	NOP
;One Wire LCD.c,145 :: 		Write_Nibble(0x30);
	LDI        R27, 48
	MOV        R2, R27
	CALL       _Write_Nibble+0
;One Wire LCD.c,146 :: 		Delay_ms(30);
	LDI        R17, 156
	LDI        R16, 215
L_One_Wire_LCD_Init29:
	DEC        R16
	BRNE       L_One_Wire_LCD_Init29
	DEC        R17
	BRNE       L_One_Wire_LCD_Init29
	NOP
	NOP
;One Wire LCD.c,147 :: 		Write_Nibble(0x30);
	LDI        R27, 48
	MOV        R2, R27
	CALL       _Write_Nibble+0
;One Wire LCD.c,148 :: 		Delay_ms(30);
	LDI        R17, 156
	LDI        R16, 215
L_One_Wire_LCD_Init31:
	DEC        R16
	BRNE       L_One_Wire_LCD_Init31
	DEC        R17
	BRNE       L_One_Wire_LCD_Init31
	NOP
	NOP
;One Wire LCD.c,149 :: 		Write_Nibble(0x20);
	LDI        R27, 32
	MOV        R2, R27
	CALL       _Write_Nibble+0
;One Wire LCD.c,150 :: 		Delay_ms(20);
	LDI        R17, 104
	LDI        R16, 229
L_One_Wire_LCD_Init33:
	DEC        R16
	BRNE       L_One_Wire_LCD_Init33
	DEC        R17
	BRNE       L_One_Wire_LCD_Init33
;One Wire LCD.c,151 :: 		One_Wire_LCD_Cmd(0x28);
	LDI        R27, 40
	MOV        R2, R27
	CALL       _One_Wire_LCD_Cmd+0
;One Wire LCD.c,152 :: 		Delay_ms(10);
	LDI        R17, 52
	LDI        R16, 242
L_One_Wire_LCD_Init35:
	DEC        R16
	BRNE       L_One_Wire_LCD_Init35
	DEC        R17
	BRNE       L_One_Wire_LCD_Init35
	NOP
;One Wire LCD.c,153 :: 		One_Wire_LCD_Cmd(0x06);
	LDI        R27, 6
	MOV        R2, R27
	CALL       _One_Wire_LCD_Cmd+0
;One Wire LCD.c,154 :: 		Delay_ms(10);
	LDI        R17, 52
	LDI        R16, 242
L_One_Wire_LCD_Init37:
	DEC        R16
	BRNE       L_One_Wire_LCD_Init37
	DEC        R17
	BRNE       L_One_Wire_LCD_Init37
	NOP
;One Wire LCD.c,155 :: 		}
L_end_One_Wire_LCD_Init:
	POP        R2
	RET
; end of _One_Wire_LCD_Init

_main:
	LDI        R27, 255
	OUT        SPL, R27
	LDI        R27, 0
	OUT        SPH, R27

;One Wire LCD.c,157 :: 		void main() {
;One Wire LCD.c,159 :: 		DDRD = 0xFF;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	LDI        R27, 255
	OUT        DDRD, R27
;One Wire LCD.c,161 :: 		One_Wire = 1;
	SBI        PORTD, 0
;One Wire LCD.c,163 :: 		One_Wire_LCD_Init();
	CALL       _One_Wire_LCD_Init+0
;One Wire LCD.c,164 :: 		One_Wire_LCD_Cmd(_LCD_CLEAR);
	LDI        R27, 1
	MOV        R2, R27
	CALL       _One_Wire_LCD_Cmd+0
;One Wire LCD.c,165 :: 		One_Wire_LCD_Cmd(_LCD_CURSOR_OFF);
	LDI        R27, 12
	MOV        R2, R27
	CALL       _One_Wire_LCD_Cmd+0
;One Wire LCD.c,167 :: 		One_Wire_LCD_Out(1,1,"One-Wire");
	LDI        R27, #lo_addr(?lstr1_One_32Wire_32LCD+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr1_One_32Wire_32LCD+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _One_Wire_LCD_Out+0
;One Wire LCD.c,168 :: 		One_Wire_LCD_Out(2,1,"Serial LCD");
	LDI        R27, #lo_addr(?lstr2_One_32Wire_32LCD+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr2_One_32Wire_32LCD+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _One_Wire_LCD_Out+0
;One Wire LCD.c,169 :: 		One_Wire_LCD_Out(3,1,"20x4");
	LDI        R27, #lo_addr(?lstr3_One_32Wire_32LCD+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr3_One_32Wire_32LCD+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 3
	MOV        R2, R27
	CALL       _One_Wire_LCD_Out+0
;One Wire LCD.c,170 :: 		One_Wire_LCD_Out(4,1,"Using 74HC595");
	LDI        R27, #lo_addr(?lstr4_One_32Wire_32LCD+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr4_One_32Wire_32LCD+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 4
	MOV        R2, R27
	CALL       _One_Wire_LCD_Out+0
;One Wire LCD.c,172 :: 		while(1){
L_main39:
;One Wire LCD.c,174 :: 		}
	JMP        L_main39
;One Wire LCD.c,175 :: 		}
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
